Attribute VB_Name = "BiDWAEP"
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'MODULE:   EPBIDAPI.BAS
'FOR:      Microsoft Visual Basic 5.0
'          BiD WAEP SDK
'LANGUAGE: ENGLISH
'DATE:     27-OCT-2003
'>>>>>>>>>>>>>>>>> SEIKO EPSON CORPORATION (C)1998-2002, ALL RIGHTS RESERVED >>>>>>>>>>>>>>>>>

'=============================================================================================
'BiD WAEP FUNCTIONS TO IMPORT
'=============================================================================================
Declare Function GetDeviceID Lib "epbidapi.dll" (ByVal PATHTYPE As Long, _
ByVal PRNPATH As String, ByRef devid As deviceid, ByRef bufflen As Long) As Long

Declare Function OpenCommunication Lib "epbidapi.dll" (ByVal PATHTYPE As Long, _
ByVal PRNPATH As String, ByVal prntype As Long) As Long

Declare Function GetInformationVB Lib "epbidapi.dll" (ByVal prnhandle As Long, _
ByVal command As String, ByRef getparm As Any, ByRef getbuff As Any, _
ByRef bufflen As Long, ByRef chcode As Any, ByRef chcodelen As Long) As Long

Declare Function SetInformation Lib "epbidapi.dll" (ByVal prnhandle As Long, _
ByVal command As String, ByRef setparm As Any, ByRef bufflen As Long) As Long

Declare Function CloseCommunication Lib "epbidapi.dll" (ByVal prnhandle As Long) _
As Long

Declare Function ValB Lib "epbidapi.dll" (ByVal s As String) As Long

'=============================================================================================
'ERROR CODES
'=============================================================================================
Global Const ERR_BASE = 0
Global Const ERR_PORT = (ERR_BASE - 1)
Global Const ERR_PRINTER = (ERR_BASE - 2)
Global Const ERR_NOTFOUND = (ERR_BASE - 3)
Global Const ERR_BUFFERSIZE = (ERR_BASE - 4)
Global Const ERR_NOTSUPPORT = (ERR_BASE - 5)
Global Const ERR_CHANNELNOTSUPPORT = (ERR_BASE - 6)
Global Const ERR_HANDLE = (ERR_BASE - 7)
Global Const ERR_BUFFERFULL = (ERR_BASE - 8)
Global Const ERR_TIMEOUT = (ERR_BASE - 9)
Global Const ERR_USERCANCEL = (ERR_BASE - 10)
Global Const ERR_NOTBLOCK = (ERR_BASE - 11)
Global Const ERR_INVALIDOPTIONDATA = (ERR_BASE - 12)
Global Const ERR_INITIALIZE = (ERR_BASE - 13)
Global Const ERR_OPTION = (ERR_BASE - 14)
Global Const ERR_PARAMETER = (ERR_BASE - 15)
Global Const ERR_COMMUNICATION = (ERR_BASE - 16)
Global Const ERR_BUSY = (ERR_BASE - 17)
Global Const ERR_INVALIDDEV = (ERR_BASE - 18)

Global Const ERR_COMMAND = (ERR_BASE - 100)
Global Const ERR_CHANNEL = (ERR_BASE - 101)
Global Const ERR_TEMPORARY = (ERR_BASE - 102)
Global Const ERR_DATAFILE = (ERR_BASE - 103)
Global Const ERR_INVALIDDATA = (ERR_BASE - 104)
Global Const ERR_MISTYPE = (ERR_BASE - 105)

'=============================================================================================
'PRINTER PATH TYPE
'=============================================================================================
Global Const TYPE_PORT = 0
Global Const TYPE_PRINTER = 1

'=============================================================================================
'PRINTER TYPE - Returned by GetDeviceID.  Choose a status structure by the printer type
'               of which you want to get status.
'=============================================================================================
Global Const PAGE = 0
Global Const SIDM_1 = 1
Global Const SIDM_2 = 2 
Global Const INJ_1 = 3
Global Const INJ_2 = 4
Global Const STATUS_COMMON = 5
Global Const NOTYPE = 6
Global Const COLOR_PAGE = 7
Global Const PAGE_2 = 8
Global Const SIDM_3 = 9
Global Const COLOR_PAGE_2 = 10

'=============================================================================================
'MISC DEFINITIONS
'=============================================================================================
Global Const MAX_PAPER = 8

'=============================================================================================
'DEVICE ID - GetDeviceID's information inside.
'=============================================================================================
Type deviceid
    mfg As String * 256
    cmd As String * 256
    mdl As String * 256
    cls As String * 256
    prntype As Long
End Type

'=============================================================================================
'STATUS - Used to get status via GetInformation.
'         Choose a structure by the printer type GetDeviceID returned.
'=============================================================================================
'---------------------------------------------------------------------------------------------
'PAGE
'---------------------------------------------------------------------------------------------
Type status1
    version As Byte
    printerid As Byte
    status As Integer
    jobname(21) As Byte
    printpage As Long
    tonerest As Byte
    unitlife As String * 1
    trayrest As Byte
    casset1rest As String * 1
    casset2rest As String * 1
    trayvol As Integer
    casset1vol As Integer
    casset2vol As Integer
    traysize As Byte
    casset1size As Byte
    casset2size As Byte
    dualprint As Byte
    aslotid As String * 1
    bslotid As String * 1
    option As String * 1
    memorysize As Byte
    casset3rest As String * 1
    casset3vol As Integer
    casset3size As Byte
End Type

'---------------------------------------------------------------------------------------------
'Color PAGE
'---------------------------------------------------------------------------------------------
Type status1C
    version As Byte
    printerid As Byte
    status As Integer
    memorysize As Integer
    ytonerest As Byte
    mtonerest As Byte
    ctonerest As Byte
    abandontoner As Byte
    oilroll As Byte
    casset4rest As String * 1
    casset4vol As Integer
    casset4size As Byte
    reserved1 As String * 4
    colorprint As Byte
    totalprint As Long
    printpage As Long
    btonerest As Byte
    unitlife As String * 1
    trayrest As Byte
    casset1rest As String * 1
    casset2rest As String * 1
    trayvol As Integer
    casset1vol As Integer
    casset2vol As Integer
    traysize As Byte
    casset1size As Byte
    casset2size As Byte
    dualprint As Byte
    aslotid As String * 1
    bslotid As String * 1
    option As String * 1
    reserved2 As String * 1
    casset3rest As String * 1
    casset3vol As Integer
    casset3size As Byte
End Type

'---------------------------------------------------------------------------------------------
'PAGE_2
'---------------------------------------------------------------------------------------------
Type status2_PAGE
    version As Byte
    printerid As Byte
    status As Integer
    memorysize As Integer
    traypapertype As Byte
    casset1papertype As Byte
    casset2papertype As Byte
    casset3papertype As Byte
    casset4papertype As Byte
    casset4rest As String * 1
    casset4vol As Integer
    casset4size As Byte
    casset5rest As String * 1
    casset5vol As Integer
    casset5size As Byte
    casset5papertype As Byte
    totalprint As Long
    faceup As String * 1
    mfmode As String * 1
    mftype As String * 1
    reserved1 As String * 1
    btonerest As Byte
    unitlife As String * 1
    trayrest As Byte
    casset1rest As String * 1
    casset2rest As String * 1
    trayvol As Integer
    casset1vol As Integer
    casset2vol As Integer
    traysize As Byte
    casset1size As Byte
    casset2size As Byte
    dualprint As Byte
    aslotid As String * 1
    bslotid As String * 1
    option As String * 1
    reserved2 As String * 1
    casset3rest As String * 1
    casset3vol As Integer
    casset3size As Byte
End Type

'---------------------------------------------------------------------------------------------
'COLOR_PAGE_2
'---------------------------------------------------------------------------------------------
Type status2C
    version As Byte
    printerid As Byte
    status As Integer
    memorysize As Integer
    ytonerest As Byte
    mtonerest As Byte
    ctonerest As Byte
    abandontoner As Byte
    oilroll As Byte
    casset4rest As String * 1
    casset4vol As Integer
    casset4size As Byte
    reserved1 As String * 1
    traypapertype As Byte
    casset1papertype As Byte
    casset2papertype As Byte
    colorprint As Byte
    totalprint As Long
    colorprintpage As Long
    btonerest As Byte
    unitlife As String * 1
    trayrest As Byte
    casset1rest As String * 1
    casset2rest As String * 1
    trayvol As Integer
    casset1vol As Integer
    casset2vol As Integer
    traysize As Byte
    casset1size As Byte
    casset2size As Byte
    casset4papertype As Byte
    aslotid As String * 1
    bslotid As String * 1
    option As String * 1
    casset3papertype As Byte
    casset3rest As String * 1
    casset3vol As Integer
    casset3size As Byte
End Type

'---------------------------------------------------------------------------------------------
'MC_PAGE_6
'---------------------------------------------------------------------------------------------
Type status6MC
	version As Byte
	printerid As Byte
	status As Integer
	memorysize As Integer
	printstatus As Integer
	warningstatus As Integer
	btonerest As String * 1
	ctonerest As String * 1
	mtonerest As String * 1
	ytonerest As String * 1	
	abandontoner As String * 1
	oilroll As String * 1
	unitlife As String * 1
	cunitlife As String * 1
	munitlife As String * 1
	yunitlife As String * 1
	trayrest As Byte
	trayvol As String * 1
	traysize As Byte
	traypapertype As Byte
	casset1rest As String * 1
	casset1vol As String * 1
	casset1size As Byte
	casset1papertype As Byte
	casset2rest As String * 1
	casset2vol As String * 1
	casset2size As Byte
	casset2papertype As Byte
	casset3rest As String * 1
	casset3vol As String * 1
	casset3size As Byte
	casset3papertype As Byte
	casset4rest As String * 1
	casset4vol As String * 1
	casset4size As Byte
	casset4papertype As Byte
	totalprint As Long
	colorprintpage As Long
	option As String * 1
	reserve As Integer
End Type
'=============================================================================================
'COLORREST - Ink QTY information included in status2_common structure for inkjet printers.
'=============================================================================================
Type colorrest
    blackrest As String * 1
    cyanrest As String * 1
    magentarest As String * 1
    yellowrest As String * 1
    lightcyanrest As String * 1
    lightmagentarest As String * 1
    grayrest As String * 1
End Type

'=============================================================================================
'COLORCAPACITY - Ink QTY information included in status2_common structure for inkjet printers.
'=============================================================================================
Type colorcapacity
    blackcapacity As String * 1
    cyancapacity As String * 1
    magentacapacity As String * 1
    yellowcapacity As String * 1
    lightcyancapacity As String * 1
    lightmagentacapacity As String * 1
End Type

'=============================================================================================
'Picture element deflection information - involved in status2_common structure
'=============================================================================================
Type headdeflection
    blackdeflection As String * 1
    cyandeflection As String * 1
    magentadeflection As String * 1
    yellowdeflection As String * 1
    lightcyandeflection As String * 1
    lightmagentadeflection As String * 1
    graydeflection As String * 1
End Type

'=============================================================================================
'WORNINGCODE - Warning information included in status2_common structure for InkJet and SIDM
'=============================================================================================
Type warningcode
    papernearend1 As String * 1
    papernearend2 As String * 1
    blacklow As String * 1
    cyanlow As String * 1
    magentalow As String * 1
    yellowlow As String * 1
    lightcyanlow As String * 1
    lightmagentalow As String * 1
End Type

'=============================================================================================
'STATUS2_COMMON
'=============================================================================================
Type status2_common
    statuscode As String * 1
    errcode As String * 1
    color As colorrest
    capacity As colorcapacity
    deflection As headdeflection
    warning As warningcode
    selfprintcode As String * 1
    csfpaperbin1 As String * 1
    csfpaperbin2 As String * 1
    paperpath As Integer
    Revision As String * 1
    reserved As Long
End Type

'=============================================================================================
'Printer type specific status information
'=============================================================================================
'---------------------------------------------------------------------------------------------
'SIDM_1
'---------------------------------------------------------------------------------------------
Type charactercode1
    version As Byte
    yy As Byte
    mm As Byte
    dd As Byte
    printline As Long
    totaltime As Integer
    csfbin1size As Integer
    csfbin2size As Integer
    csfbin3size As Integer
    paperwidth As Integer
End Type

'---------------------------------------------------------------------------------------------
'SIDM_2
'---------------------------------------------------------------------------------------------
Type charactercode2
    version As Byte
    yy As Byte
    mm As Byte
    dd As Byte
    printline As Long
    totaltime As Integer
    resetprintline As Long
End Type

'---------------------------------------------------------------------------------------------
'No INJ_1 specific information available.
'---------------------------------------------------------------------------------------------

'---------------------------------------------------------------------------------------------
'INJ_2
'---------------------------------------------------------------------------------------------
Type charactercode3
    version As Byte
    csfbin1size As Integer
    csfbin1type As Byte
    csfbin1rest As Byte
    csfbin2size As Integer
    csfbin2type As Byte
    csfbin2rest As Byte
    simmvol As Byte
End Type

'---------------------------------------------------------------------------------------------
'SIDM_3
'---------------------------------------------------------------------------------------------
Type mediastatus1
    CDcode As charactercode2
    mediaregistration1 As Integer
    mediaregistration2 As Integer
    mediaregistration3 As Integer
    mediaregistration4 As Integer
    mediaregistration5 As Integer
    mediaregistration6 As Integer
    mediaregistration7 As Integer
    mediaregistration8 As Integer
End Type

'=============================================================================================
'CM DATA - Applied for only SIDM printers with paper registration functionarity.
'           Used by GetInformation and SetInformation.
'=============================================================================================
Type cmdata
    number As String * 1
    name As String * 21
    papercategory As String * 1
    paperpath As String * 1
    vertical As Integer
    horizontal As Integer
    kindofpaper As String * 1
    status As String * 1
End Type

'=============================================================================================
'STRING COMMAND - Exclusive for SIDM printers w/MR command feature.
'                 Used by GetInformation and SetInformation.
'=============================================================================================
'---------------------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------------------
Type stringcommand
    command As String * 1024
    reserved1 As Long
    reserved2 As Long
End Type

'[EOF]
